    // Function for geting particular country data via URL or country name.
async function fetchDataAsync() {

    structured_data = [];
    url = "https://restcountries.com/v3.1/all"
    //Getting Data from the API fetch
    const response = await fetch(url);
    var data = await response.json();
    // Saving data of objects in varaiables 
    // console.log(data)
    empty_array_countries = [];
    for (let i = 0; i< 200; i++){
        empty_array_countries.push(data[i]);
    }

    return empty_array_countries;

}
async function fetchDataAsync_fullname(url_fullName) {

    structured_data = [];
    //Getting Data from the API fetch
    const response = await fetch(url_fullName);
    var data = await response.json();
    // Saving data of objects in varaiables 
    // console.log(data)
    if (data.message){
        console.log(data.message);
    }else {
        console.log(data);
    }
    return data;

}





//till here single panel javascript ends.

function onBack(){
    var display_invisible = document.getElementById("card-div");
    var searchbox = document.getElementById("enter_keyPress");
    var back_button_var = document.getElementById("back_button");
    var api_search_var = document.getElementById("api-search");
    searchbox.style.display = "flex";
    api_search_var.style.display = "flex";
    back_button_var.style.display = "none";
    display_invisible.style.display = "flex";

    // Save the ids at page load//////////////////////////////////////////////
    var img_holder = document.getElementById("image-holder");
    var content_holder = document.getElementById("content-holder");
    /////////Changing style.display to none for hidden div.
    img_holder.style.display = "none";
    content_holder.style.display = "none";

}

function onEnter() {
    var display_invisible = document.getElementById("card-div");
    var searchbox = document.getElementById("enter_keyPress");
    var back_button_var = document.getElementById("back_button");
    var api_search_var = document.getElementById("api-search");
    display_invisible.style.display = "none";
    searchbox.style.display = "none";
    back_button_var.style.display = "flex";
    api_search_var.style.display = "none";

}

// JS to create multiple pred defined divs //
async function create_div () {
    ///// Fetching country names in an array_countryName
    data = await fetchDataAsync();
    array_countryName = [];
    for (let m = 0; m < 100; m++){
        array_countryName.push(data[m]);
    }
    console.log(array_countryName); 
    
    // Creation of inner elements 
    for (let i = 0; i<100;i++) {
    const parent_div = document.getElementById("card-div");
    var div = document.createElement('div');
    div.id = array_countryName[i].name.common;
    div.innerHTML = `<img src="${array_countryName[i].flags.png}" alt="" class="flag-container"></img>`;
    div.className = 'card-actual';
    div.setAttribute("onclick","onClickDivNewPage(this.id)");
    parent_div.appendChild(div);



    const child_div = document.getElementById(array_countryName[i].name.common);
    var inner_div = document.createElement('div');
    inner_div.className = 'card-detail';
    inner_div.id = `id-${array_countryName[i].name.common}`;
    child_div.appendChild(inner_div);

    
    const country_name_div = document.getElementById(`id-${array_countryName[i].name.common}`);
    var country_div = document.createElement('div');
    country_div.className = 'country-name';
    country_div.innerHTML = `<h2>${array_countryName[i].name.common}</h2`
    country_name_div.appendChild(country_div);

    const country_detail_div = document.getElementById(`id-${array_countryName[i].name.common}`);
    var country_detail = document.createElement('div');
    country_detail.className = 'country-detail';
    country_detail.innerHTML = `<p class="padding-details">Population : ${array_countryName[i].population}</p>
    <p class="padding-details">Region :  ${array_countryName[i].region}</p>
    <p class="padding-details">Capital :  ${array_countryName[i].capital}</p>`;
    country_detail_div.appendChild(country_detail);
    ////Till here X 

    } 
}



// single panel page javascript written from here and down 
async function searchboxNextPage (url){
    
    ///// Fetching country names in an array_countryName
    nextPanel_data = await fetchDataAsync_fullname(url);
    panelData = nextPanel_data[0];
    document.getElementById("default-img").src = panelData.flags.png;
    var navtiveName = document.getElementById("population");
    navtiveName.innerHTML = `Population : ${panelData.population}`;
}

async function onClickDivNewPage (clickedId){   
    var img_holder = document.getElementById("image-holder");
    var content_holder = document.getElementById("content-holder");
    console.log(clickedId);
    fetchUrl = `https://restcountries.com/v3.1/name/${clickedId}?fullText=true`;
    fetchDataAsync_fullname(fetchUrl);
    onEnter();
    ///////////////////////////////////////////////////////////////
    searchboxNextPage(fetchUrl);
    img_holder.style.display = "flex";
    content_holder.style.display = "flex";
}

//till here single panel javascript ends.




// Loading on page refresh///////
/////////////////////////////////
/////////////////////////////////
/////////////////////////////////
/////////////////////////////////
/////////////////////////////////
/////////////////////////////////
/////////////////////////////////
////////////////////////////////\
///////////////////////////////\\
//////////////////////////////\\\
/////////////////////////////\\\\
async function start_onload(){
    fetchDataAsync();
    create_div();  
    //////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////
    // Save the ids at page load//////////////////////////////////////////////
    var img_holder = document.getElementById("image-holder");
    var content_holder = document.getElementById("content-holder");
    /////////Changing style.display to none for hidden div.
    img_holder.style.display = "none";
    content_holder.style.display = "none";
    // On Key press enter run this function for the search tab.
    var inputEnter = document.getElementById("enter_keyPress");
    inputEnter.addEventListener("keypress", function keyPress(e){
        if (e.key === "Enter"){
            search_query =  document.getElementById("enter_keyPress").value;
            console.log(search_query);
            fetchUrl = `https://restcountries.com/v3.1/name/${search_query}?fullText=true`;
            fetchDataAsync_fullname(fetchUrl);
            onEnter();
            ///////////////////////////////////////////////////////////////
            searchboxNextPage(fetchUrl);
            img_holder.style.display = "flex";
            content_holder.style.display = "flex";
        } 
            
    });
}






















///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
////////////////////----------------/////////////////////////----------------//////////////
/////////////////////----------------////////////////////////-----------------/////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
/////////////////////////////////////////////////||////////////////////////////////////////
///////////////////////////  //////////////////////////////////////  //////////////////////
////////////////////////////  /////////////////////////////////////  //////////////////////
/////////////////////////////  //////////////////////////////////  ////////////////////////
//////////////////////////////   /////////////////////////////   //////////////////////////
////////////////////////////////   /////////////////////////   ////////////////////////////
//////////////////////////////////   ///////////////////   ////////////////////////////////
/////////////////////////////////////     /////////     ///////////////////////////////////
/////////////////////////////////////////           ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////